'''
Jeu : Tetris

Le but du jeu est de poser le plus de blocs possible sans être bloqué (grille entièrement pleine). Une ligne entièrement remplie
s'autodétruira.

Script : Python.
Modules : Pygame; Random

Fichiers : tetrisgrille.py, classes.py, constantes.py, images & sprites

'''
																								# Importation des modules :
import pygame																						# Pygame
import random																						# Random
from pygame.locals import *																			# Pygame +																			# Classes
from constantes import *																			# Constantes

																								# Initialisation des modules :
pygame.init()																						# Pygame général
pygame.mixer.init(frequence_son,-16,2,2048)															# Module son

																								# Initialisation de la fenêtre Pygame :
fenetre = pygame.display.set_mode((1280, 720))														# Taille
icone = pygame.image.load(image_icone)																# Charge l'icone
pygame.display.set_icon(icone)																		# Icone
pygame.display.set_caption(titre_fenetre)															# Titre


tps = 0
clock = pygame.time.Clock()
			

# FORME DES BLOCS
stop=0
bloc=1
couleur = 255
S =[[[[0,0],[0,0],[0,0],[0,0]],
     [[0,0],[0,0],[1,couleur],[1,couleur]],
     [[0,0],[1,couleur],[1,couleur],[0,0]],
     [[0,0],[0,0],[0,0],[0,0]]],
    [[[0,0],[1,couleur],[0,0],[0,0],],
     [[0,0],[1,couleur],[1,couleur],[0,0]],
     [[0,0],[0,0],[1,couleur],[0,0]],
     [[0,0],[0,0],[0,0],[0,0]]],
    [[[0,0],[0,0],[0,0],[0,0]],
     [[0,0],[0,0],[1,couleur],[1,couleur]],
     [[0,0],[1,couleur],[1,couleur],[0,0]],
     [[0,0],[0,0],[0,0],[0,0]]],
    [[[0,0],[1,couleur],[0,0],[0,0],],
     [[0,0],[1,couleur],[1,couleur],[0,0]],
     [[0,0],[0,0],[1,couleur],[0,0]],
     [[0,0],[0,0],[0,0],[0,0]]]]

rotate=0
forme = S
grille = [[[0,0] for x in range(10)] for y in range(24)]

def newblock():
    global bloc
    for y in range(4):
        for x in range(3,7):
            grille[y][x] = forme[rotate][y][x-3]
            bloc=1
            

newblock()



#Fonction de descente du bloc

def descente():
    global stop
    global bloc
    if bloc==1:
        for y in range(24):
            for x in range(10):
                if grille[y][x][0]==1:
                    if y == 23:
                        stop=1
                    elif grille[y+1][x][0]==2:
                        stop=1

# Descente du bloc si bloc inférieur non solide
    if stop !=1:
        for y in range(23, -1, -1):
            for x in range(10):
                if grille[y][x][0]==1:
                    grille[y+1][x] = grille[y][x]
                    grille[y][x] = [0,0]
#Solidification du bloc si le bloc est en bas ou bien s'il entre en colision avec un bloc
    if stop ==1:
        for y in range(23, -1, -1):
            for x in range(10):
                if grille[y][x][0]==1:
                    grille[y][x][0]=2
                    bloc=0

#Déplacement à gauche
def gauche():
    global bloc
    gauchenon=0
    if bloc==1:
        for y in range(24):
            for x in range(10):
                if grille[y][x][0]==1:
                    if x==0:
                        gauchenon=1
                    else:
                        if grille[y][x-1][0]==2:
                            gauchenon=1

#Déplacement à gauche si rien à gauche ou pas de mur

    if gauchenon!=1:
        for y in range(24):
            for x in range(10):
                if grille[y][x][0]==1:
                    grille[y][x-1] = grille[y][x]
                    grille[y][x] = [0,0]
              

#Déplacement à droite

def droite():
    global bloc
    droitenon=0
    if bloc==1:
        for y in range(24):
            for x in range(10):
                if grille[y][x][0]==1:
                    if x==9:
                        droitenon=1
                    else:
                        if grille[y][x+1][0]==2:
                            droitenon=1

#Déplacement à droite si rien à droite ou pas de mur

    if droitenon!=1:
        for y in range(24):
            for x in range(9, -1, -1):
                if grille[y][x][0]==1:
                    grille[y][x+1] = grille[y][x]
                    grille[y][x] = [0,0]

#Rotation des blocs
def rotation():
    global bloc
    global rotate
    moyennex=0
    moyenney=0
    coinx=0
    coiny=0
    rotatenon=0
    if bloc==1:
        if rotate==3:
            rotate=0
        else :
            rotate=rotate+1

            
#On calcule la moyenne des coordonnées des blocs
    for y in range(24):
            for x in range(10):
                if grille[y][x][0]==1:
                    moyennex=moyennex+x
                    moyenney=moyenney+y
#Pour en déduire le coin haut gauche
    if moyennex%4==0:
        coinx=int(moyennex/4)
    else:
        coinx=int(moyennex/4-1.5)
    if moyenney%4==0:
        coiny=int(moyenney/4)
    else:
        coiny=int(moyenney/4-1.5)
    
    for i in range(4):
        for j in range(4):
            print(coinx+j,coiny+i)


#On vérifie qu'il n'y a rien    
    for y in range(4):
        for x in range(4):
            if forme[rotate][y][x][0]==1:
                if grille[coiny+y][coinx+x][0]==2:
                    rotatenon=1
#On remplace
    if rotatenon !=1:
        for y in range(4):
            for x in range(4):
                grille[coiny+y][coinx+x]=forme[rotate][y][x]
        

rotation() 
print(grille)

jeux=0
vitesse=0
continuer = 1	
continuer_accueil = 1
while continuer:	
    
    	#BOUCLE D'ACCUEIL
    while continuer_accueil:
        # Rafraichissement	
        accueil = pygame.image.load(image_accueil).convert()										# Chargement du menu
        fenetre.blit(accueil, (0,0))
        pygame.display.flip()

		#Limitation de vitesse de la boucle
        pygame.time.Clock().tick(30)
        for event in pygame.event.get():
            
            if event.type == QUIT or event.type == KEYDOWN and event.key == K_ESCAPE:			# Détection pour la fermeture du programme 
                continuer = 0
                continuer_accueil = 0
                pygame.display.quit()
																								# Variable de choix de difficulté (niveau)
				
            elif event.type == KEYDOWN:

				#Lancement du mode facile
                if event.key == K_UP:
                    continuer_accueil = 0														# On quitte l'accueil
                    jeux = 1
                    vitesse=1													# On choisit le niveau facile

				# Lancement du mode difficile
                elif event.key == K_DOWN:
                    continuer_accueil = 0														# On quitte l'acceuil
                    jeux = 1
                    vitesse=2
                    pygame.mixer.music.stop			
    
    if jeux == 1:
        fond = pygame.image.load(image_fond).convert()
        bloc = pygame.image.load(blocimg).convert()
        
    while jeux:
        pygame.time.Clock().tick(30)
        timer=clock.tick()
        bonton+=timer
        if bonton > 500:
            descente()
            bonton = 0
        print(grille)

        for event in pygame.event.get():
		
																									# Si l'utilisateur quitte :
            if event.type == QUIT:
                continuer_jeu = 0																		# Arrêt de la boucle jeu
                continuer = 0
                break																			# Arrêt de la boucle principale

            elif event.type == KEYDOWN:

                if event.key == K_ESCAPE:															# Retour menu si "échap"
                    jeux = 0
                    continuer_accueil = 1



        fenetre.blit(fond, (0,0))
        for y in range(4,24):
            for x in range(10):
                if grille[y][x][0]!=0:
                    fenetre.blit(bloc,(x*35+465,(y-4)*35))
        fenetre.blit(bloc,(x*35+465,y*35))
        pygame.display.flip()


"""                   
                elif event.key == K_RIGHT:
					bloc1.deplacer('droite')																# Droite
				elif event.key == K_LEFT:
					bloc1.deplacer('gauche')																# Gauche
				elif event.key == K_UP:
					bloc1.deplacer('haut')																# Pivoter dans le sens horaire
				elif event.key == K_DOWN:
					bloc1.deplacer('bas')
"""

        